# Die Programmoberfläche von Sonic Pi

Sonic PI hat eine sehr einfache Oberfläche zum Coden von Musik. Schauen wir uns das einmal genauer an.

![Sonic Pi Interface](:/images/tutorial/GUI.png)


* *A* - Play-Steuerung (Buttons für Abspielen/Pause)
* *B* - Editor-Steuerung (Buttons für den Editor)
* *C* - Info and Help (Information und Hilfe)
* *D* - Code Editor (Code Editor)
* *E* - Log Viewer (Log-Fenster)
* *F* - Help System (Hilfesystem)

Mit diese pinkfarbenen Buttons kannst du Klänge abspielen und stoppen. Es gibt einen *Run*-Button, mit dem der Code im Editor ausgeführt wird, der *Stop* hält den ablaufenden Code an, mit *Save* kannst du den Code in einer Dateispeichern und *Record* nimmt den gerade laufenden Sound auf (in einer WAV-Datei).

## B. Editor-Steuerung

Diese orangefarbenen Buttons steuern den Code-Editor. Mit den *Size
+* and *Size -*-Buttons kannst du den Text vergrößern und verkleinern. Der *Align*-Button rückt den Code ordentlich ein, damit er professioneller aussieht und besser lesbar ist.

## C. Information und Hilfe

Diese blauen Buttons bieten dir den Zugriff auf Informationen, die Hilfe und die Voreinstellungen. Der *Info*-Button öffnet ein Fenster mit Informationen über Sonic Pi selbst - das Entwicklerteam, die Geschichte, Beitragende und die Community. Der *Help*-Button zeigt/verbirgt das Hilfesystem (*F*) und der *Prefs*-Button zeigt/verbirgt das Fenster für Voreinstellungen, über die du einige grundsätzliche Systemparameter regeln kannst.

## D. Code-Editor

Dies ist der Bereich, wo du deinen Code schreibst und deine Musik komponierst/aufführst. Es ist ein einfacher Texteditor, mit dem du Code eingeben oder löschen, auschneiden und einfügen kannst usw.; so ähnlich wie eine einfache Word-Version oder Google Docs. Der Editor färbt bestimmte Begriffe automatisch ein, je nachdem, welche Bedeutung sie innerhalb des Codes haben. Am Anfang ist das vielleicht ein wenig merkwürdig, aber du wirst es bald nützlich finden. Zum Beispiel siehst du, dass etwas eine Nummer ist, weil es blau eingefärbt dargestellt wird.

## E. Log Viewer

Wenn du deinen Code ablaufen läßt, siehst du im Log-Fenster, was das Programm gerade tut. Standardmäßig siehst du eine Nachricht für jeden erzeugten Klang und die exakte Zeit, zu der der Klang ausgelöst wurde. Das kann sehr hilfreich sein, um Fehler in deinem Code zu entdecken und zu verstehen, was dein Code macht.

## F. Help System

Das Hilfe-System im unteren Bereich des Programmfensters ist einer der wichtigsten Teile von Sonic Pi. Du kanns es ein- und ausblenden, indem du den blauen *Hilfe*-Button klickst. Es enthält Hilfe und Informationen über alle Aspekte von Sonic Pi, einschließlich dieses Tutorials, eine Liste der mitgelieferten Synths, Samples, Beispiele (examples), Effekte (FX) sowie eine komplette Liste aller Funktionen, die Sonic Pi bereitstellt, um damit Musik zu coden.
