# Synths wechseln

Bis jetzt hatten wir viel Spaß mit Tönen und Samples. Aber wahrscheinlich wird dir langsam langweilig, immer denselben Klang zu hören. Ist das alles, was Sonic Pi anzubieten hat? Besteht das Live Coding nicht aus mehr als Pieptönen? Aber klar doch, und in diesem Abschnitt sehen wir uns die spannende Auswahl an Sounds an, die Sonic Pi mitbringt.

## Synths

Sonic Pi bringt eine Palette an Instrumenten mit, die synths heissen, eine *Kurzform für Synthesizer*. Samples sind vorher aufgenommene Klänge; demgegenüber können synths neue Klänge erzeugen, je nachdem, wie du sie anlegst (wie das geht, werden wir später sehen). Sonic Pi's synths sind sehr mächtig und ausdrucksstark und man kann viel Spass damit haben. Als erstes lernen wir, wie man einen synth auswählt, den man benutzen möchte.

## Brilliante Sägen und Prophets[^1]

Einen spaßigen Sound ergibt die *Sägezahn-Welle* - probieren wir es mal aus:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Nehmen wir einen anderen Klang - den *Prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Wie wäre es damit, beide Sounds zu verbinden? Zuerst einen nach dem anderen:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Nun zur selben Zeit:

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Hast du bemerkt, dass das `use_synth`-Kommando nur die nachfolgenden `play`-Kommandos beeinflusst? Stell es dir vor als einen *großen Schalter* - neue Aufrufe von `play` werden immer den synth benutzen, auf den synth gerade zeigt. Du kannst diesen Schalter mit `use_synth` auf einen synth umschalten.

## Synths entdecken

Du kannst herausfinden, welche synths Sonic Pi für dich bereitstellt, indem du im Menü auf der linken Seite Synths anklickst (gleich über Fx). Es gibt über 20 Stück. Hier sind einige meiner Lieblings-Synths:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Spiel mal ein bisschen herum indem du *in deinem Stück die synths wechselst*. Kombiniere unterschiedliche synths oder setze sie für unterschiedliche Stellen in deinem Stück ein.

[^1]: Die Name "Sägezahn" (engl. saw) kommt von der Wellenform, die dieser Synthesizer produziert. Wenn man sich diesen Klang mit einem Oszilloskop anzeigen lässt, sieht er aus wie die Zähne einer Säge. Der Name "Prophet" kommt von einem Synthesizer, den der amerikanische Hersteller Sequential Circuits Ende der 70er Jahre herstellte.
