# Samples ausdehnen

Jetzt, wo wir eine ganze Menge Synths und Samples spielen können, um damit Musik zu machen, wird es Zeit zu lernen, wie wir diese Synths und Samples verändern könnten, um unsere Musik einzigartiger und spannender zu machen. Als erstes sehen wir uns an, wie wir Samples *strecken* und *stauchen* können.

## Wie Samples Klänge darstellen

Samples sind aufgenommene Klänge, die als eine Menge von Zahlen gespeichert werden; die Zahlen sagen dem Lautsprecherkegel, wie er sich bewegen muss, um den Klang wiederzugeben. Der Lautsprecherkegel kann sich nach innen und nach außen bewegen, also müssen die Zahlen angeben, wie weit sich der Kegel zu jedem Zeitpunkt nach innern oder nach außen bewegen soll. Um einen Klang als Aufnahme wirklichkeitsgetreu wiederzugeben, muss das Sample je Sekunde viele tausend Zahlen speichern. Sonic Pi nimmt diese Liste von Zahlen und gibt sie in der richtigen Samplerate [^1] an den Lautsprecher in deinem Computer genauso, dass der Klang richtig wiedergegeben wird. Jedoch macht es auch Spaß die Raten zu ändern, mit der die Zahlen an den Lautsprecher geschickt werden, und so den Klang zu ändern.

## Die Samplerate ändern

Lass uns mit einem der Ambient-Klänge spielen: `ambi_choir`. Um den mit Standard-Samplerate wiederzugeben, kannst du dem `sample` das Argument[^2] `rate:` übergeben:

```
sample :ambi_choir, rate: 1
```

Der Sample wird so mit der normalen Samplerate (1) abgespielt, also nichts Besonderes. Aber wir können die Zahl jederzeit verändern. Was ist mit `0.5`:

```
sample :ambi_choir, rate: 0.5
```

Wow! Was ist denn jetzt los? Also, hier passieren zwei Dinge. Erstens braucht der Sample zweimal solange und zweitens klingt er eine Oktave niedriger. Sehen wir uns das mal genauer an.

## Lasst uns stretchen

Mit dem Amen Break-Sample macht das strecken und zusammenstauchen besonders viel Spass. Mit der normalen Samplerate könnten wir den in einem *Drum 'n' Bass*-Track verwenden:

```
sample :loop_amen
```

Wenn wir die Samplerate ändern, dann können wir die Stilrichtungen wechseln. Versuche es mal mit halber Samplerate für *Hip-Hop der alten Schule*:

```
sample :loop_amen, rate: 0.5
```

Wenn wir ihn beschleunigen, dann betreten wir das *Jungle*-Territorium:

```
sample :loop_amen, rate: 1.5
```

Und als letzten Trick - sehen wir mal, was passiert, wenn wir eine negative Rate angeben:

```
sample :loop_amen, rate: -1
```

Wow! Er wird *rückwärts* gespielt! Jetzt probier herum mit vielen unterschiedlichen Samples und unterschiedlichen Sampleraten. Versuch's mit sehr hohen oder mit verrückt langsamen. Finde heraus, welche spannenden Klänge du damit produzieren kannst.

## Eine einfache Erklärung der Samplerate

Man kann sich Samples gut als Sprungfedern vorstellen. Wenn man die Samplerate verändert, ist das so, als ob man die Feder zusammendrückt oder auseinanderzieht. Wenn du ein Sample mit der doppelten Samplerate abspielst, dann drückst du die Feder zusammen, bis sie nur noch die Hälfte ihrer normalen Länge hat. Das Sample braucht also auch nur die Hälfte der Abspielzeit. Wenn du das Sample mit halber Samplerate spielst, dann ziehst du die Feder auf ihre doppelte Länge auseinander. Das Sample dauert also nun doppelt so lange. Je mehr du zusammendrückst (höhere Rate), desto kürzer das Sample, je mehr du auseinanderziehst (geringere Rate), desto länger dauert das Sample.

Wenn man eine Feder zusammendrückt, dann erhöht man ihre Dichtheit (die Anzahl der Windungen je Zentimeter) - das ist so ähnlich wie bei Sample, der *höher klingt*. Wenn man die Feder auseinanderzieht, dann verringert sich ihre Dichtheit, vergleichbar einem Klang, der tiefer klingt.

## Die Mathematik hinter der Samplerate

(Dieser Abschnitt ist für diejenigen, die genaueres wissen möchten. Wenn nicht, könnt ihr den gerne überspringen...)

Wie wir oben gesehen haben, wird ein Sample durch eine lange Liste von Zahlen dargestellt, die dem Lautsprecher sagt, wo er zu welchem Zeitpunkt sein soll. Wir können diese Zahlenliste nehmen und eine Kurve zeichnen, die ungefähr so aussieht:

![sample graph](:/images/tutorial/sample.png)

Vielleicht hast du Bilder wie dieses schon einmal gesehen. Das ist die *Kurvenform* eines Samples. Es ist bloß eine Kurve, die aus Zahlen gebildet ist. Typischerweise wird eine solche Kurve aus 44100 Datenpunkten je Sekunde gebildet (das hat mit dem Nyquist-Shannon-Abtasttheorem[^3] zu tun). Wenn also das Sample 2 Sekunden dauert, dann wird die Kurve aus 88200 Zahlen gebildet, die wir an den Lautsprecher mit einer Datenrate von 44100 Datenpunkten pro Sekunde senden. Natürlich könnten wir ihn mit der doppelten Datenrate senden, also 88200 Datenpunkten pro Sekunde. Dann würde das Sample nur eine Sekunde lang dauern. Wir können ihn auch mit der halben Datenrate abspielen; das wären dann 22050 Datenpunkte pro Sekunde und würde 4 Sekunden dauern.

Die Dauer des Samples ist also abhängig von der Datenrate:

* Wird die Abtastrate verdoppelt, halbiert das die Abspielzeit,
* wird die Abtastrate halbiert, dann verdoppelt sich die Abspielzeit.
* Verwendest du eine Abtastrate von einem Viertel, dann vervierfachst du die Abspielzeit,
* verwendest du eine Abtastrate von 1/10, dann dauert die Abspielzeit 10mal länger.

Wir können das in einer Formel zusammenfassen:

```
neue_sample_dauer = (1 / rate) * sample_dauer
```

Wenn du die Samplerate veränderst, beeinflusst das auch die Tonhöhen des Samples. Die Frequenz oder Tonhöhe einer Kurve wird dadurch bestimmt, wie schnell sie hoch und runter geht. Unsere Gehirne machen aus schnellen Bewegungen eines Lautsprechers hohe Töne und aus langsamen tiefe. Deshalb kannst du manchmal sogar sehen, wie sich ein großer Basslautsprecher bewegt, wenn ein sehr tiefer Ton rauskommt. Er bewegt sich dann wesentlich langsamer, als ein Lautsprecher, der hohe Töne wiedergibt.

Wenn du eine Kurve nimmst und sie zusammendrückst, dann wird sie je Sekunde öfter hoch und runter gehen als vorher. Ihr Ton wird dann auch höher sein. (Wenn man die Auf- und Abbewegungen je Sekunde verdoppelt (Oszillationen), dann wird die Frequenz, also Tonhöhe, verdoppelt. Also, *wenn du dein Sample mit doppelter Sampkerate abspielst, dann wird er auch doppelt so hoch klingen*; andererseits: *eine Halbierung der Samplerate wird auch die Frequenz halbieren*. Andere Samplerates werden dementsprechend die Tonhöhe beinflussen.

[^1]: Die Samplerate heißt auch Samplingrate oder Abtastrate; *rate* für die Frequenz, mit der Sonic Pi die Zahlen, die im Sample den Klang darstellen an den Lautsprecher sendet.

[^2]: *Argument* ist ein anderer Begriff für *Parameter*; an dieser Stelle bedeutet beide Begriffe dasselbe.

[^3]: Wenn du genau wissen willst, worum es da geht, dann schlag es bei Wikipedia nach: http://de.wikipedia.org/wiki/Nyquist-Shannon-Abtasttheorem
