# Variablen

Es ist sehr nützlich beim coden, Namen für Dinge zu vergeben. Sonic Pi macht es dir hier sehr leicht: schreib' einfach den Namen, den du gerne verwenden möchtest, dann ein Gleichheitszeichen (`=`) und dann das Ding, welches du dir merken möchtest.

```
sample_name = :loop_amen
```

Hier haben wir uns das Symbol `:loop_amen` mit der Variable `sample_name` *gemerkt*. Wir können nun `sample_name` überall da benutzen, wo wir auch `loop_amen` benutzen könnten. Zum Beispiel:


```
sample_name = :loop_amen
sample sample_name
```

Es gibt drei Hauptgründe, Variablen in Sonic Pi zu nutzen: Bedeutung vermitteln, Wiederholung steuern und Ergebnisse von Dingen speichern:

## Bedeutung vermitteln

Wenn du Code schreibst, könnest du denken, dass du dem Computer einfach nur sagst, was er tun soll - solange der Computer das versteht, ist es okay. Es ist jedoch wichtig daran zu denken, dass nicht nur der Computer den Code liest. Andere Leute könnten den Code auch lesen und versuchen zu verstehen, was da vor sich geht. Wahrscheinlich wirst du den Code auch später selbst wieder lesen und möchtest verstehen, was er bedeutet. Obwohl dir jetzt vielleicht alles offensichtlich erscheint - wahrscheinlich ist es für andere nicht ganz so offensichtlich und vielleicht nicht einmal für dich in der Zukunft!

Kommentare sind eine Möglichkeit, anderen dabei zu helfen, deinen Code zu verstehen. Weiterhin kannst du sinnvolle Variablennamen verwenden. Sie dir diesen Code an:

```
sleep 1.7533
```

Warum steht hier die Zahl `1.533`. Woher kommt diese Zahl? Was bedeutet sie? Sieh dir zum Vergleich diesen Code an:

```
loop_amen_duration = 1.7533
sleep loop_amen_duration
```

Aha, jetzt ist viel klarer, was `1.7533` bedeutet: Es ist die Dauer des Samples `loop_amen`! Natürlich kannst du jetzt sagen, warum nicht einfach schreiben:

```
sleep sample_duration(:loop_amen)
```

Das ist natürlich ein sehr guter Weg, die Absicht mitzuteilen, die hinter dem Code steht.

## Wiederholung steuern

Oftmals siehst du in deinem Code viele Wiederholungen, und wenn du irgendwo etwas ändern willst, musst du das an vielen Stellen tun. Schau dir mal diesen Code an:

```
sample :loop_amen
sleep sample_duration(:loop_amen)
sample :loop_amen, rate: 0.5
sleep sample_duration(:loop_amen, rate: 0.5)
sample :loop_amen
sleep sample_duration(:loop_amen)
```

Hier machen wir eine ganze Menge mit dem `:loop_amen`! Was wäre, wenn du das Ganze mit einem anderen Loop-Sample wie zum Beispiel `:loop_garzul` hören wollten? Wir müssten alle `:loop_amen` suchen und mit `:loop_garzul` ersetzen. Das mag in Ordnung sein, wenn du viel Zeit hast - aber was, wenn du gerade auf einer Bühne stehst? Manchmal hat man nicht den Luxus, Zeit zu haben - vor allem dann nicht, wenn du willst, dass die Leute weitertanzen.

Was wäre, wenn du den Code so geschrieben hättest:

```
sample_name = :loop_amen
sample sample_name
sleep sample_duration(sample_name)
sample sample_name, rate: 0.5
sleep sample_duration(sample_name, rate: 0.5)
sample sample_name
sleep sample_duration(sample_name)
```

Das tut genau dasselbe wie der Code weiter oben (probier's aus). Außerdem bekommen wir die Möglichkeit, durch die Änderung der einen Zeile `sample_name = :loop_amen` in `sample_name = :loop_garzul` die vielen anderen Stellen durch die Magie der Variablen zu verändern.

## Ergebnisse von Dingen speichern

Wenn man schließlich die Ergebnisse von irgendwelchen Dingen speichern möchte, dann ist das ebenfalls ein guter Grund dafür, Variablen zu verwenden. Du möchtest vielleicht irgendetwas mit der Dauer eines Samples anstellen:

```
sd = sample_duration(:loop_amen)
```

Wir können nun `sd` überall da einsetzen, wo wir die Länge von `:loop_amen` brauchen.

Noch wichtiger vielleicht: Eine Variable erlaubt es uns das Ergebnis eines Aufrufs von `play` oder `sample` zu speichern:

```
s = play 50, release: 8
```

Jetzt haben wir `s` als Variable eingefangen und gemerkt, und das erlaubt es uns einen Synth zu steuern, während er läuft:

```
s = play 50, release: 8
sleep 2
control s, note: 62
```

Wir schauen uns später noch genauer an, wie man Synth steuert.
