# Shortcut Cheatsheet

The following is a summary of the main shortcuts available within Sonic
Pi. Please see Section 10.1 for motivation and background.

## Conventions

In this list, we use the following conventions (where *Meta* is *Alt* on
Windows and Linux and *Cmd* on Mac):

* `C-a` means hold the *Control* key then press the *a* key whilst holding them both at the same time, then releasing.
* `M-r` means hold the *Meta* key and then press the *r* key whilst holding them both at the same time, then releasing.
* `M-Z` means hold the *Meta* key, then the *Shift* key, then finally the *z* key all at the same time, then releasing.
* `C-M-f` means hold the *Control* key, then press *Meta* key, finally the *f* key all at the same time, then releasing.

## Main Application Manipulation

* `M-r` - Run code
* `M-s` - Stop code
* `M-i` - Toggle Help System
* `M-p` - Toggle Preferences

## Selection/Copy/Paste

* `M-a` - Select all
* `M-c` - Copy selection to paste buffer
* `M-x` - Cut selection to paste buffer
* `M-v` - Paste from paste buffer to editor

## Editor Manipulation

* `M-+` - Increase text size
* `M--` - Decrease text size
* `M-m` - Align text
* `C-g` - Escape

## Navigation

* `C-a` - Move to beginning of line
* `C-e` - Move to end of line
* `C-p` - Move to previous line
* `C-n` - Move to next line
* `C-f` - Move forward one character
* `C-b` - Move backward one character
* `C-M-f` - Move forward one word
* `C-M-b` - Move backward one word
* `C-h` - Delete previous character
* `C-d` - Delete next character
* `C-l` - Center editor

## Advanced Editor Features

* `C-i` - Show docs for word under cursor
* `M-z` - Undo
* `M-Z` - Redo
* `C-k` - Delete to the end of the line
